import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Enemy is a danger for you. 
 * @LiuLufei
 * @10.31.2019 
 * the picture comes from https://timgsa.baidu.com/timg?image&quality=80&
 * size=b9999_10000&sec=1572529655115&di=b9a0de06631
 * 556ff249c6a506be6c482&imgtype=0&src=http%3A%2F%2F
 * vpic.video.qq.com%2F3388556%2Fk0540u9ygg2_ori_3.jpg
 */
public class Enemy extends Actor
{
    //use two pictures to make it looks like alive.
    private GreenfootImage image1;
    private GreenfootImage image2;
    
    public Enemy()
    {   
        //use two pictures to make it looks like alive.
        image1 = new GreenfootImage("zhangyuge.png");
        image2 = new GreenfootImage("zhangyuge2.png");
        setImage(image1);
    }
    
    
    public void act() 
    {
        //if touching Myfish,remove it.
        checkCollision();
        //add move action.
        switchImage();
        //make the fish move and turn randmoly.
        moveControl();
        //check whether it is at edge.if true,turn back.
        checkIsAtEdge();
        //check whether CatFish is still in screen;
        checkIsInScreen();
        
    }
    public void checkIsInScreen()
    {
        /*
         * check whether CatFish is still in screen;
         */
        if (getX() == 0)
        {
            MyWorld myworld = (MyWorld)getWorld();
            myworld.removeObject(this);
        }
    }
    public void moveControl()
    {
        /*
            make the fish move and turn randmoly.
        */
        if (Greenfoot.getRandomNumber(100)<2)
        {
            turn(Greenfoot.getRandomNumber(360)-180);
        }
        move(Greenfoot.getRandomNumber(1)-6);
        //if you want to play with your friends.
        //checkKeyPress();
    }
    
    public void checkIsAtEdge()
    {
        /*
         * check whether it is at edge.if true,turn back.
        */
        if (isAtEdge())
        {
            turn(180);
        }
    }
    
    public void switchImage()
    {   /*
        add move action.
        */
        if (getImage() == image1) 
        {
            setImage(image2);
        }
        else 
        {
            setImage(image1);
        }
    }
    
    private void checkCollision()
    {   /*
            if touching Myfish,remove it.
        */
        if(isTouching(Myfish.class))
        {
            removeTouching(Myfish.class);
            Greenfoot.stop();
            MyWorld myworld = (MyWorld)getWorld();
            myworld.showText("GAME OVER! YOUR FINALL SOCRE IS "+ MyWorld.score, 800, 450);
            
            Greenfoot.playSound("game-over.wav");
        }
    }
    
    private void checkKeyPress()
    {
        /*
         * control your fish up, down, right, and left, if you want to play with your friends.
         */
        if (Greenfoot.isKeyDown("w")) 
        {
            setLocation(getX(), getY()-8);
        }
        
        if (Greenfoot.isKeyDown("s")) 
        {
            setLocation(getX(), getY()+8);
        }
        
        if (Greenfoot.isKeyDown("d")) 
        {
            setLocation(getX()+4, getY());
        }
        
        if (Greenfoot.isKeyDown("a")) 
        {
            setLocation(getX()-4, getY());
        }
    }
}
